/* EXPERIMENTAL */
#ifndef __GNOME_NET_ADDRESS_H__
#define __GNOME_NET_ADDRESS_H__

#include <libgnome/gnome-defs.h>

typedef enum {
  GNOME_NET_ADDRESS_INVALID = 0, /* e.g. dns lookup failed */
  GNOME_NET_ADDRESS_INET4   = 1, /* IPv4 */
  GNOME_NET_ADDRESS_INET6   = 2  /* IPv6 */
} GnomeNetAddressType;
  
typedef struct {
  GnomeNetAddressType type; 
  gpointer address;
  guint address_size; /* this must be in _host_ byte order */
} GnomeNetAddress;

GnomeNetAddress *
gnome_net_address_new(GnomeNetAddressType type);

GnomeNetAddress *
gnome_net_address_dup(GnomeNetAddress *addr);

void
gnome_net_address_destroy(GnomeNetAddress *addr);

#endif __GNOME_NET_ADDRESS_H__
