/* EXPERIMENTAL */
#ifndef __GNOME_STRING_SOCKET_H__
#define __GNOME_STRING_SOCKET_H__

#include <gnome-socket.h>

/* ***** PLEASE NOTE ******
 * If you don't use ares or GNU adns, you'll have to call gnome_dns_init() 
 * before using these functions (usually in main() after gnome_init()). See
 * http://developer.gnome.org/doc/API/libgnomeui/gnomeui-gnome-dns.html
 * for more info
 * ************************/

typedef void (*GnomeStringSocketCallback)(guint tag, 
					  GnomeSocketInfo info,
					  gint extra_info,
					  GIOChannel *channel,
					  gchar *str,
					  gpointer data);

guint
gnome_string_socket_connect (const gchar *hostname,
			     GnomeNetAddressType addr_type,
			     guint port,
			     const gchar *delim,
			     GnomeStringSocketCallback callback,
			     gpointer callback_data);

guint
gnome_string_socket_listen(guint port, const gchar *delim,
			   GnomeStringSocketCallback callback,
			   gpointer callback_data,
			   GnomeSocketInfo *info,
			   gint *error_no);

/* TODO
GnomeSocketCallback
gnome_string_socket_get_callback(guint tag);

gboolean
gnome_string_socket_set_callback(guint tag, 
				 GnomeStringSocketCallback callback);

GnomeNetAddress *
gnome_socket_get_addr(guint tag);

guint
gnome_socket_get_port(guint tag);

gpointer
gnome_socket_get_callback_data(guint tag);

gboolean
gnome_socket_set_callback_data(guint tag, gpointer callback_data);

*/

gboolean
gnome_string_socket_close(guint tag);

#endif /* __GNOME_STRING_SOCKET_H__ */
